diff a/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad b/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad
--- a/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad
+++ b/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad
@@ -20,92 +20,331 @@
 // or visit www.oracle.com if you need additional information or have any
 // questions.
 //
 //
 
-source_hpp %{
-#include "gc/shenandoah/shenandoahBarrierSetAssembler.hpp"
-#include "gc/shenandoah/c2/shenandoahSupport.hpp"
+source %{
+#include "gc/shenandoah/shenandoahBarrierSet.hpp"
+#include "gc/shenandoah/shenandoahBarrierSetAssembler_x86.hpp"
+#include "gc/shenandoah/c2/shenandoahBarrierSetC2.hpp"
+%}
+
+instruct storeP_shenandoah(memory mem, any_RegP src, rRegP tmp1, rRegP tmp2, rRegP tmp3, rFlagsReg cr)
+%{
+  match(Set mem (StoreP mem src));
+  predicate(UseShenandoahGC && n->as_Store()->barrier_data() != 0);
+  effect(TEMP tmp1, TEMP tmp2, TEMP tmp3, KILL cr);
+  ins_cost(125); // XXX
+  format %{ "movq    $mem, $src\t# ptr" %}
+  ins_encode %{
+    __ lea($tmp1$$Register, $mem$$Address);
+    ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                       $tmp1$$Register /* addr */,
+                                                       $tmp2$$Register /* pre_val */,
+                                                       $tmp3$$Register /* tmp */);
+    __ movq(Address($tmp1$$Register, 0), $src$$Register);
+    ShenandoahBarrierSet::assembler()->card_barrier_c2(this, masm,
+                                                       noreg /* addr */,
+                                                       $tmp1$$Register /* addr_tmp */,
+                                                       $tmp2$$Register /* tmp */);
+  %}
+  ins_pipe(ialu_mem_reg);
+%}
+
+instruct storeN_shenandoah(memory mem, rRegN src, rRegP tmp1, rRegP tmp2, rRegP tmp3, rFlagsReg cr)
+%{
+  match(Set mem (StoreN mem src));
+  predicate(UseShenandoahGC && n->as_Store()->barrier_data() != 0);
+  effect(TEMP tmp1, TEMP tmp2, TEMP tmp3, KILL cr);
+  ins_cost(125); // XXX
+  format %{ "movl    $mem, $src\t# ptr" %}
+  ins_encode %{
+    __ lea($tmp1$$Register, $mem$$Address);
+    ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                       $tmp1$$Register /* addr */,
+                                                       $tmp2$$Register /* pre_val */,
+                                                       $tmp3$$Register /* tmp */);
+    __ movl(Address($tmp1$$Register, 0), $src$$Register);
+    ShenandoahBarrierSet::assembler()->card_barrier_c2(this, masm,
+                                                       noreg /* addr */,
+                                                       $tmp1$$Register /* addr_tmp */,
+                                                       $tmp2$$Register /* tmp */);
+  %}
+  ins_pipe(ialu_mem_reg);
+%}
+
+instruct encodePAndStoreN_shenandoah(memory mem, any_RegP src, rRegP tmp1, rRegP tmp2, rRegP tmp3, rFlagsReg cr)
+%{
+  match(Set mem (StoreN mem (EncodeP src)));
+  predicate(UseShenandoahGC && n->as_Store()->barrier_data() != 0);
+  effect(TEMP tmp1, TEMP tmp2, TEMP tmp3, KILL cr);
+  ins_cost(125); // XXX
+  format %{ "encode_heap_oop $src\n\t"
+            "movl   $mem, $src\t# ptr" %}
+  ins_encode %{
+    __ lea($tmp1$$Register, $mem$$Address);
+    ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                       $tmp1$$Register /* addr */,
+                                                       $tmp2$$Register /* pre_val */,
+                                                       $tmp3$$Register /* tmp */);
+    __ movq($tmp3$$Register, $src$$Register);
+    if ((barrier_data() & ShenandoahBarrierCardMarkNotNull) == 0) {
+      __ encode_heap_oop($tmp3$$Register);
+    } else {
+      __ encode_heap_oop_not_null($tmp3$$Register);
+    }
+    __ movl(Address($tmp1$$Register, 0), $tmp3$$Register);
+    ShenandoahBarrierSet::assembler()->card_barrier_c2(this, masm,
+                                                       noreg /* addr */,
+                                                       $tmp1$$Register /* addr_tmp */,
+                                                       $tmp2$$Register /* tmp */);
+  %}
+  ins_pipe(ialu_mem_reg);
 %}
 
 instruct compareAndSwapP_shenandoah(rRegI res,
-                                    memory mem_ptr,
+                                    indirect mem,
                                     rRegP tmp1, rRegP tmp2,
                                     rax_RegP oldval, rRegP newval,
                                     rFlagsReg cr)
 %{
-  match(Set res (ShenandoahCompareAndSwapP mem_ptr (Binary oldval newval)));
-  match(Set res (ShenandoahWeakCompareAndSwapP mem_ptr (Binary oldval newval)));
-  effect(TEMP tmp1, TEMP tmp2, KILL cr, KILL oldval);
+  match(Set res (CompareAndSwapP mem (Binary oldval newval)));
+  match(Set res (WeakCompareAndSwapP mem (Binary oldval newval)));
+  predicate(UseShenandoahGC && n->as_LoadStore()->barrier_data() != 0);
+  effect(TEMP_DEF res, TEMP tmp1, TEMP tmp2, KILL cr, KILL oldval);
 
-  format %{ "shenandoah_cas_oop $mem_ptr,$newval" %}
+  format %{ "shenandoah_cas_oop $mem,$newval" %}
 
   ins_encode %{
-    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
-                                                   $res$$Register, $mem_ptr$$Address, $oldval$$Register, $newval$$Register,
-                                                   false, // swap
-                                                   $tmp1$$Register, $tmp2$$Register
-                                                   );
+    ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                       noreg /* addr */,
+                                                       $oldval$$Register /* pre_val */,
+                                                       $tmp2$$Register /* tmp */);
+    ShenandoahBarrierSet::assembler()->cmpxchg_oop_c2(this, masm,
+                                                      $res$$Register, $mem$$Address, $oldval$$Register, $newval$$Register, $tmp1$$Register, $tmp2$$Register,
+                                                      /*exchange*/ false);
+    ShenandoahBarrierSet::assembler()->card_barrier_c2(this, masm,
+                                                       $mem$$Register /* addr */,
+                                                       $tmp1$$Register /* addr_tmp */,
+                                                       $tmp2$$Register /* tmp */);
   %}
   ins_pipe( pipe_cmpxchg );
 %}
 
 instruct compareAndSwapN_shenandoah(rRegI res,
-                                    memory mem_ptr,
+                                    indirect mem,
                                     rRegP tmp1, rRegP tmp2,
                                     rax_RegN oldval, rRegN newval,
                                     rFlagsReg cr) %{
-  match(Set res (ShenandoahCompareAndSwapN mem_ptr (Binary oldval newval)));
-  match(Set res (ShenandoahWeakCompareAndSwapN mem_ptr (Binary oldval newval)));
-  effect(TEMP tmp1, TEMP tmp2, KILL cr, KILL oldval);
+  match(Set res (CompareAndSwapN mem (Binary oldval newval)));
+  match(Set res (WeakCompareAndSwapN mem (Binary oldval newval)));
+  predicate(UseShenandoahGC && n->as_LoadStore()->barrier_data() != 0);
+  effect(TEMP_DEF res, TEMP tmp1, TEMP tmp2, KILL cr, KILL oldval);
 
-  format %{ "shenandoah_cas_oop $mem_ptr,$newval" %}
+  format %{ "shenandoah_cas_oop $mem,$newval" %}
 
   ins_encode %{
-    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
-                                                   $res$$Register, $mem_ptr$$Address, $oldval$$Register, $newval$$Register,
-                                                   false, // swap
-                                                   $tmp1$$Register, $tmp2$$Register
-                                                   );
+    guarantee(UseCompressedOops, "must be compressed oops");
+    if (ShenandoahSATBBarrierStubC2::needs_barrier(this)) {
+      __ movl($tmp1$$Register, $oldval$$Register);
+      __ decode_heap_oop($tmp1$$Register);
+    ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                       noreg /* addr */,
+                                                       $tmp1$$Register /* pre_val */,
+                                                       $tmp2$$Register /* tmp */);
+    }
+    ShenandoahBarrierSet::assembler()->cmpxchg_oop_c2(this, masm,
+                                                      $res$$Register, $mem$$Address, $oldval$$Register, $newval$$Register, $tmp1$$Register, $tmp2$$Register,
+                                                      /*exchange*/ false);
+    ShenandoahBarrierSet::assembler()->card_barrier_c2(this, masm,
+                                                       $mem$$Register /* addr */,
+                                                       $tmp1$$Register /* addr_tmp */,
+                                                       $tmp2$$Register /* tmp */);
   %}
   ins_pipe( pipe_cmpxchg );
 %}
 
-instruct compareAndExchangeN_shenandoah(memory mem_ptr,
+instruct compareAndExchangeN_shenandoah(indirect mem,
                                         rax_RegN oldval, rRegN newval,
-                                        rRegP tmp1, rRegP tmp2,
+                                        rRegP tmp1, rRegP tmp2, rRegP tmp3,
                                         rFlagsReg cr) %{
-  match(Set oldval (ShenandoahCompareAndExchangeN mem_ptr (Binary oldval newval)));
-  effect(TEMP tmp1, TEMP tmp2, KILL cr);
+  match(Set oldval (CompareAndExchangeN mem (Binary oldval newval)));
+  predicate(UseShenandoahGC && n->as_LoadStore()->barrier_data() != 0);
+  effect(TEMP tmp1, TEMP tmp2, TEMP tmp3, KILL cr);
 
-  format %{ "shenandoah_cas_oop $mem_ptr,$newval" %}
+  format %{ "shenandoah_cas_oop $mem,$newval" %}
 
   ins_encode %{
-    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
-                                                   noreg, $mem_ptr$$Address, $oldval$$Register, $newval$$Register,
-                                                   true, // exchange
-                                                   $tmp1$$Register, $tmp2$$Register
-                                                   );
+    guarantee(UseCompressedOops, "must be compressed oops");
+    if (ShenandoahSATBBarrierStubC2::needs_barrier(this)) {
+      __ movl($tmp1$$Register, $oldval$$Register);
+      __ decode_heap_oop($tmp1$$Register);
+      ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                         noreg /* addr */,
+                                                         $tmp1$$Register /* pre_val */,
+                                                         $tmp2$$Register /* tmp */);
+    }
+    ShenandoahBarrierSet::assembler()->cmpxchg_oop_c2(this, masm,
+                                                      noreg, $mem$$Address, $oldval$$Register, $newval$$Register, $tmp1$$Register, $tmp2$$Register,
+                                                      /*exchange*/ true);
+    ShenandoahBarrierSet::assembler()->load_ref_barrier_c2(this, masm,
+                                                           $oldval$$Register /* obj */,
+                                                           $mem$$Register /* addr */,
+                                                           $tmp1$$Register /* tmp1 */,
+                                                           $tmp2$$Register /* tmp2 */,
+                                                           $tmp3$$Register /* tmp3 */,
+                                                           true /* narrow */);
+    ShenandoahBarrierSet::assembler()->card_barrier_c2(this, masm,
+                                                       $mem$$Register /* addr */,
+                                                       $tmp1$$Register /* addr_tmp */,
+                                                       $tmp2$$Register /* tmp */);
   %}
   ins_pipe( pipe_cmpxchg );
 %}
 
-instruct compareAndExchangeP_shenandoah(memory mem_ptr,
+instruct compareAndExchangeP_shenandoah(indirect mem,
                                         rax_RegP oldval, rRegP newval,
                                         rRegP tmp1, rRegP tmp2,
                                         rFlagsReg cr)
 %{
-  match(Set oldval (ShenandoahCompareAndExchangeP mem_ptr (Binary oldval newval)));
+  match(Set oldval (CompareAndExchangeP mem (Binary oldval newval)));
+  predicate(UseShenandoahGC && n->as_LoadStore()->barrier_data() != 0);
   effect(KILL cr, TEMP tmp1, TEMP tmp2);
   ins_cost(1000);
 
-  format %{ "shenandoah_cas_oop $mem_ptr,$newval" %}
+  format %{ "shenandoah_cas_oop $mem,$newval" %}
 
   ins_encode %{
-    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
-                                                   noreg, $mem_ptr$$Address, $oldval$$Register, $newval$$Register,
-                                                   true,  // exchange
-                                                   $tmp1$$Register, $tmp2$$Register
-                                                   );
+    ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                       noreg /* addr */,
+                                                       $oldval$$Register /* pre_val */,
+                                                       $tmp2$$Register /* tmp */);
+    ShenandoahBarrierSet::assembler()->cmpxchg_oop_c2(this, masm,
+                                                      noreg, $mem$$Address, $oldval$$Register, $newval$$Register, $tmp1$$Register, $tmp2$$Register,
+                                                      /*exchange*/ true);
+    ShenandoahBarrierSet::assembler()->load_ref_barrier_c2(this, masm,
+                                                           $oldval$$Register /* obj */,
+                                                           $mem$$Register /* addr */,
+                                                           noreg /* tmp1 */,
+                                                           $tmp1$$Register /* tmp2 */,
+                                                           $tmp2$$Register /* tmp3 */,
+                                                           false /* narrow */);
+    ShenandoahBarrierSet::assembler()->card_barrier_c2(this, masm,
+                                                       $mem$$Register /* addr */,
+                                                       $tmp1$$Register /* addr_tmp */,
+                                                       $tmp2$$Register /* tmp */);
   %}
   ins_pipe( pipe_cmpxchg );
 %}
+
+instruct getAndSetP_shenandoah(indirect mem, rRegP newval, rRegP tmp1, rRegP tmp2, rFlagsReg cr)
+%{
+  match(Set newval (GetAndSetP mem newval));
+  predicate(UseShenandoahGC && n->as_LoadStore()->barrier_data() != 0);
+  effect(TEMP tmp1, TEMP tmp2, KILL cr);
+  format %{ "xchgq    $newval, $mem" %}
+  ins_encode %{
+    assert_different_registers($mem$$Register, $newval$$Register);
+    __ xchgq($newval$$Register, Address($mem$$Register, 0));
+    ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                       noreg /* addr */,
+                                                       $newval$$Register /* pre_val */,
+                                                       $tmp1$$Register /* tmp */);
+    ShenandoahBarrierSet::assembler()->load_ref_barrier_c2(this, masm,
+                                                           $newval$$Register /* obj */,
+                                                           $mem$$Register /* addr */,
+                                                           noreg /* tmp1 */,
+                                                           $tmp1$$Register /* tmp2 */,
+                                                           $tmp2$$Register /* tmp3 */,
+                                                           false /* narrow */);
+    ShenandoahBarrierSet::assembler()->card_barrier_c2(this, masm,
+                                                       $mem$$Register /* addr */,
+                                                       $tmp1$$Register /* addr_tmp */,
+                                                       $tmp2$$Register /* tmp */);
+  %}
+  ins_pipe(pipe_cmpxchg);
+%}
+
+instruct getAndSetN_shenandoah(indirect mem, rRegN newval, rRegP tmp1, rRegP tmp2, rRegP tmp3, rFlagsReg cr)
+%{
+  match(Set newval (GetAndSetN mem newval));
+  predicate(UseShenandoahGC && n->as_LoadStore()->barrier_data() != 0);
+  effect(TEMP tmp1, TEMP tmp2, TEMP tmp3, KILL cr);
+  format %{ "xchgq    $newval, $mem" %}
+  ins_encode %{
+    assert_different_registers($mem$$Register, $newval$$Register);
+    __ xchgl($newval$$Register, Address($mem$$Register, 0));
+    if (ShenandoahSATBBarrierStubC2::needs_barrier(this)) {
+      __ movl($tmp1$$Register, $newval$$Register);
+      __ decode_heap_oop($tmp1$$Register);
+      ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                         noreg /* addr */,
+                                                         $tmp1$$Register /* pre_val */,
+                                                         $tmp2$$Register /* tmp */);
+    }
+    ShenandoahBarrierSet::assembler()->load_ref_barrier_c2(this, masm,
+                                                           $newval$$Register /* obj */,
+                                                           $mem$$Register /* addr */,
+                                                           $tmp1$$Register /* tmp1 */,
+                                                           $tmp2$$Register /* tmp2 */,
+                                                           $tmp3$$Register /* tmp3 */,
+                                                           true /* narrow */);
+    ShenandoahBarrierSet::assembler()->card_barrier_c2(this, masm,
+                                                       $mem$$Register /* addr */,
+                                                       $tmp1$$Register /* addr_tmp */,
+                                                       $tmp2$$Register /* tmp */);
+  %}
+  ins_pipe(pipe_cmpxchg);
+%}
+
+instruct loadP_shenandaoh(rRegP dst, memory mem, rRegP tmp1, rRegP tmp2, rRegP tmp3, rFlagsReg cr)
+%{
+  match(Set dst (LoadP mem));
+  predicate(UseShenandoahGC && n->as_Load()->barrier_data() != 0);
+  effect(TEMP_DEF dst, TEMP tmp1, TEMP tmp2, TEMP tmp3, KILL cr);
+  ins_cost(125); // XXX
+  format %{ "movq    $dst, $mem\t# ptr" %}
+  ins_encode %{
+    __ movq($dst$$Register, $mem$$Address);
+    ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                       noreg /* addr */,
+                                                       $dst$$Register /* pre_val */,
+                                                       $tmp1$$Register /* tmp */);
+    __ lea($tmp3$$Register, $mem$$Address);
+    ShenandoahBarrierSet::assembler()->load_ref_barrier_c2(this, masm,
+                                                           $dst$$Register /* obj */,
+                                                           $tmp3$$Register /* addr */,
+                                                           noreg /* tmp1 */,
+                                                           $tmp1$$Register /* tmp2 */,
+                                                           $tmp2$$Register /* tmp3 */,
+                                                           false /* narrow */);
+  %}
+  ins_pipe(ialu_reg_mem); // XXX
+%}
+
+instruct loadN_shenandoah(rRegN dst, indirect mem, rRegP tmp1, rRegP tmp2, rRegP tmp3, rFlagsReg cr)
+%{
+  match(Set dst (LoadN mem));
+  predicate(UseShenandoahGC && n->as_Load()->barrier_data() != 0);
+  effect(TEMP_DEF dst, TEMP tmp1, TEMP tmp2, TEMP tmp3, KILL cr);
+  ins_cost(125); // XXX
+  format %{ "movl    $dst, $mem\t# compressed ptr" %}
+  ins_encode %{
+    __ movl($dst$$Register, $mem$$Address);
+    if (ShenandoahSATBBarrierStubC2::needs_barrier(this)) {
+      __ movl($tmp1$$Register, $dst$$Register);
+      __ decode_heap_oop($tmp1$$Register);
+      ShenandoahBarrierSet::assembler()->satb_barrier_c2(this, masm,
+                                                         noreg /* addr */,
+                                                         $tmp1$$Register /* pre_val */,
+                                                         $tmp2$$Register /* tmp */);
+    }
+    ShenandoahBarrierSet::assembler()->load_ref_barrier_c2(this, masm,
+                                                           $dst$$Register /* obj */,
+                                                           $mem$$Register /* addr */,
+                                                           $tmp1$$Register /* tmp1 */,
+                                                           $tmp2$$Register /* tmp2 */,
+                                                           $tmp3$$Register /* tmp3 */,
+                                                           true /* narrow */);
+  %}
+  ins_pipe(ialu_reg_mem); // XXX
+%}
diff a/src/hotspot/share/adlc/formssel.cpp b/src/hotspot/share/adlc/formssel.cpp
--- a/src/hotspot/share/adlc/formssel.cpp
+++ b/src/hotspot/share/adlc/formssel.cpp
@@ -788,14 +788,10 @@
        !strcmp(_matrule->_rChild->_opType,"CheckCastPP")  ||
        !strcmp(_matrule->_rChild->_opType,"GetAndSetP")   ||
        !strcmp(_matrule->_rChild->_opType,"GetAndSetN")   ||
        !strcmp(_matrule->_rChild->_opType,"RotateLeft")   ||
        !strcmp(_matrule->_rChild->_opType,"RotateRight")   ||
-#if INCLUDE_SHENANDOAHGC
-       !strcmp(_matrule->_rChild->_opType,"ShenandoahCompareAndExchangeP") ||
-       !strcmp(_matrule->_rChild->_opType,"ShenandoahCompareAndExchangeN") ||
-#endif
        !strcmp(_matrule->_rChild->_opType,"StrInflatedCopy") ||
        !strcmp(_matrule->_rChild->_opType,"VectorCmpMasked")||
        !strcmp(_matrule->_rChild->_opType,"VectorMaskGen")||
        !strcmp(_matrule->_rChild->_opType,"VerifyVectorAlignment")||
        !strcmp(_matrule->_rChild->_opType,"CompareAndExchangeP") ||
@@ -3651,13 +3647,10 @@
     "LoadVectorGather", "StoreVectorScatter", "LoadVectorGatherMasked", "StoreVectorScatterMasked",
     "LoadRange", "LoadKlass", "LoadNKlass", "LoadL_unaligned", "LoadD_unaligned",
     "CompareAndSwapB", "CompareAndSwapS", "CompareAndSwapI", "CompareAndSwapL", "CompareAndSwapP", "CompareAndSwapN",
     "WeakCompareAndSwapB", "WeakCompareAndSwapS", "WeakCompareAndSwapI", "WeakCompareAndSwapL", "WeakCompareAndSwapP", "WeakCompareAndSwapN",
     "CompareAndExchangeB", "CompareAndExchangeS", "CompareAndExchangeI", "CompareAndExchangeL", "CompareAndExchangeP", "CompareAndExchangeN",
-#if INCLUDE_SHENANDOAHGC
-    "ShenandoahCompareAndSwapN", "ShenandoahCompareAndSwapP", "ShenandoahWeakCompareAndSwapP", "ShenandoahWeakCompareAndSwapN", "ShenandoahCompareAndExchangeP", "ShenandoahCompareAndExchangeN",
-#endif
     "GetAndSetB", "GetAndSetS", "GetAndAddI", "GetAndSetI", "GetAndSetP",
     "GetAndAddB", "GetAndAddS", "GetAndAddL", "GetAndSetL", "GetAndSetN",
     "ClearArray"
   };
   int cnt = sizeof(needs_ideal_memory_list)/sizeof(char*);
diff a/src/hotspot/share/gc/shared/c2/barrierSetC2.hpp b/src/hotspot/share/gc/shared/c2/barrierSetC2.hpp
--- a/src/hotspot/share/gc/shared/c2/barrierSetC2.hpp
+++ b/src/hotspot/share/gc/shared/c2/barrierSetC2.hpp
@@ -302,12 +302,10 @@
   virtual Node* obj_allocate(PhaseMacroExpand* macro, Node* mem, Node* toobig_false, Node* size_in_bytes,
                              Node*& i_o, Node*& needgc_ctrl,
                              Node*& fast_oop_ctrl, Node*& fast_oop_rawmem,
                              intx prefetch_lines) const;
 
-  virtual Node* ideal_node(PhaseGVN* phase, Node* n, bool can_reshape) const { return nullptr; }
-
   // These are general helper methods used by C2
   enum ArrayCopyPhase {
     Parsing,
     Optimization,
     Expansion
@@ -315,32 +313,22 @@
 
   virtual bool array_copy_requires_gc_barriers(bool tightly_coupled_alloc, BasicType type, bool is_clone, bool is_clone_instance, ArrayCopyPhase phase) const { return false; }
   virtual void clone_at_expansion(PhaseMacroExpand* phase, ArrayCopyNode* ac) const;
 
   // Support for GC barriers emitted during parsing
-  virtual bool has_load_barrier_nodes() const { return false; }
-  virtual bool is_gc_pre_barrier_node(Node* node) const { return false; }
   virtual bool is_gc_barrier_node(Node* node) const { return false; }
-  virtual Node* step_over_gc_barrier(Node* c) const { return c; }
 
   // Support for macro expanded GC barriers
-  virtual void register_potential_barrier_node(Node* node) const { }
-  virtual void unregister_potential_barrier_node(Node* node) const { }
   virtual void eliminate_gc_barrier(PhaseMacroExpand* macro, Node* node) const { }
   virtual void eliminate_gc_barrier_data(Node* node) const { }
-  virtual void enqueue_useful_gc_barrier(PhaseIterGVN* igvn, Node* node) const {}
-  virtual void eliminate_useless_gc_barriers(Unique_Node_List &useful, Compile* C) const {}
 
   // Allow barrier sets to have shared state that is preserved across a compilation unit.
   // This could for example comprise macro nodes to be expanded during macro expansion.
   virtual void* create_barrier_state(Arena* comp_arena) const { return nullptr; }
   // If the BarrierSetC2 state has barrier nodes in its compilation
   // unit state to be expanded later, then now is the time to do so.
   virtual bool expand_barriers(Compile* C, PhaseIterGVN& igvn) const { return false; }
-  virtual bool optimize_loops(PhaseIdealLoop* phase, LoopOptsMode mode, VectorSet& visited, Node_Stack& nstack, Node_List& worklist) const { return false; }
-  virtual bool strip_mined_loops_expanded(LoopOptsMode mode) const { return false; }
-  virtual bool is_gc_specific_loop_opts_pass(LoopOptsMode mode) const { return false; }
   // Estimated size of the node barrier in number of C2 Ideal nodes.
   // This is used to guide heuristics in C2, e.g. whether to unroll a loop.
   virtual uint estimated_barrier_size(const Node* node) const { return 0; }
   // Whether the given store can be used to initialize a newly allocated object.
   virtual bool can_initialize_object(const StoreNode* store) const { return true; }
@@ -353,19 +341,10 @@
 
 #ifdef ASSERT
   virtual void verify_gc_barriers(Compile* compile, CompilePhase phase) const {}
 #endif
 
-  virtual bool final_graph_reshaping(Compile* compile, Node* n, uint opcode, Unique_Node_List& dead_nodes) const { return false; }
-
-  virtual bool escape_add_to_con_graph(ConnectionGraph* conn_graph, PhaseGVN* gvn, Unique_Node_List* delayed_worklist, Node* n, uint opcode) const { return false; }
-  virtual bool escape_add_final_edges(ConnectionGraph* conn_graph, PhaseGVN* gvn, Node* n, uint opcode) const { return false; }
-  virtual bool escape_has_out_with_unsafe_object(Node* n) const { return false; }
-
-  virtual bool matcher_find_shared_post_visit(Matcher* matcher, Node* n, uint opcode) const { return false; };
-  virtual bool matcher_is_store_load_barrier(Node* x, uint xop) const { return false; }
-
   // Whether the given phi node joins OOPs from fast and slow allocation paths.
   static bool is_allocation(const Node* node);
   // Elide GC barriers from a Mach node according to elide_dominated_barriers().
   virtual void elide_dominated_barrier(MachNode* mach) const { }
   // Elide GC barriers from instructions in 'accesses' if they are dominated by
